/* tables.c - contains code for various operations that are performed
 * on the Global Offset Table and the Procedure Linkage Table */
/* Written by Owen Klan  -  November 2002 */

#include <stdio.h>
#include <elf.h>
#include <string.h>

#include "elfdump.h"

/* Procedure that will display the DWORD entries from the GOT */
void display_got(Elf32_Ehdr *header, char *image)
{
    Elf32_Shdr *sec;
    unsigned int *got = NULL;
    int num_secs;
    int found = 0;
    int i = 0;
    
    sec = (Elf32_Shdr *)(image + eword_swap(header->e_shoff));
    
    /* Find the .got section */
    num_secs = ehalf_swap(header->e_shnum);
    for (i = 0; i < num_secs; i++, sec++) {
	if (strncmp((name_table + eword_swap(sec->sh_name)), ".got", 4) == 0) {
	    /* Found what sure does look like the GOT... */
	    found = 1;
	    break;
	}
    }
    if (!found) {
	fprintf(stdout, "Could not locate the Global Offset Table!\n");
	return;
    }
    
    /* Now run through the DWORDS within the GOT */
    got = (unsigned int *)(image + eword_swap(sec->sh_offset));
    fprintf(stdout, "\nGlobal Offset Table Contents\n");
    fprintf(stdout, "Offset  Value\n");
    for (i = 0; i < (eword_swap(sec->sh_size) / 4); i++, got++) {
	fprintf(stdout, " %4X   %08X\n", (i * 4),
		*(unsigned int *)(got));
    }
}
